import { useEffect, useState } from 'react';
import { useQuery } from '../useQuery/useQuery';
export var usePaginatedQuery = function (action, actionProps, initFetch) {
    if (initFetch === void 0) { initFetch = true; }
    var _a = useState(false), initialized = _a[0], setInitialized = _a[1];
    var _b = useState(action.apply(void 0, actionProps)), queryAction = _b[0], setQueryAction = _b[1];
    var _c = useState([]), response = _c[0], setResponse = _c[1];
    var _d = useQuery(queryAction, initFetch), error = _d.error, loading = _d.loading, queryFetch = _d.fetch, queryResponse = _d.response;
    useEffect(function () {
        if (initialized) {
            queryFetch();
        }
        setInitialized(true);
    }, [queryAction]);
    useEffect(function () {
        if (queryResponse) {
            setResponse(response.concat(queryResponse));
        }
    }, [queryResponse]);
    var fetch = function (props) {
        setQueryAction(action.apply(void 0, props));
    };
    return {
        error: error,
        fetch: fetch,
        loading: loading,
        response: response,
    };
};
